/*
 * Distance.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.app;

import java.io.*;
import java.util.*;
import misao.util.*;

public class Distance {
    public static void main ( String[] args ) throws Exception {
	System.out.println("Calculate angular distance between two positions.");

	DataInputStream din = new DataInputStream(System.in);

	System.out.println("Input positions: ");
	System.out.println("  ex. R.A.= 12h 4m31.2s  Decl.= - 0o15'");
	System.out.println("  acceptable style: 12 4 31.2 -0 15 0");
	System.out.print("Position 1: ");
	String pos_str1 = din.readLine();
	System.out.print("Position 2: ");
	String pos_str2 = din.readLine();

	Coor coor1 = Coor.createCoor(pos_str1);
	Coor coor2 = Coor.createCoor(pos_str2);

	double dist = coor1.angular_distance(coor2);
	double pa = coor1.direction(coor2);

	System.out.println("" + dist + " deg.");
	System.out.println("" + (dist * 60.0) + " arcmin.");
	System.out.println("" + (dist * 3600.0) + " arcsec.");
	System.out.println("p.a. = " + pa);
    }
}
