/*
 * VariableStarFinder.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.app;

import java.io.*;
import java.util.*;
import misao.util.*;
import misao.host.*;

public class VariableStarFinder {
    public static void main ( String[] args ) throws Exception {	
	Coor coor = null;
	double area_size = 0.0;

	if (args.length == 0) {
	    System.out.println("Find variable stars in the identification database.");

	    DataInputStream din = new DataInputStream(System.in);

	    System.out.println("Positions (J2000.0): ");
	    System.out.println("  ex. R.A.= 12h 4m31.2s  Decl.= - 0o15'");
	    System.out.println("  acceptable style: 12 4 31.2 -0 15 0");
	    System.out.print("Positions (J2000.0): ");
	    String position = din.readLine();

	    System.out.println("Search area size: ");
	    System.out.println("  acceptable style: 1 deg");
	    System.out.println("                    60 arcmin");
	    System.out.println("                    3600 arcsec");
	    System.out.print("Search area size: ");
	    String area_size_str = din.readLine();

	    coor = Coor.createCoor(position);
	    area_size = Astro.doubleDegreeValueOf(area_size_str);
	} else {
	    coor = Coor.createCoor(args[0]);
	    area_size = Astro.doubleDegreeValueOf(args[1]);
	}

	ReferenceCatalogBaseManager ref_catalog_manager = new ReferenceCatalogBaseManager();

	Vector ref_list = ref_catalog_manager.findData(coor, area_size);
	for (int i = 0 ; i < ref_list.size() ; i++) {
	    ReferenceData data = (ReferenceData)ref_list.elementAt(i);
	    double r = data.getCoor().angular_distance(coor) * 3600.0;
	    System.out.println(data.getName() + "\t" + Astro.toString(r, 10, 8).trim() + "\"");
	    System.out.println(data.getRecord());
	}
    }
}
