/*
 * MagnitudeDatabaseUpdateElement.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.database;

import misao.util.*;
import misao.pixy.*;
import misao.host.*;

public class MagnitudeDatabaseUpdateElement implements MapElement {
    public ReferenceName ref_name;
    public MagnitudeDatabaseRecord mag_record;

    public MagnitudeDatabaseUpdateElement ( ReferenceName _ref_name, MagnitudeDatabaseRecord _mag_record ) {
	ref_name = _ref_name;
	mag_record = _mag_record;
    }

    public String getName ( ) {
	return ref_name.getName();
    }

    public Position getPosition ( ) {
	Coor coor = new Coor();
	if (IrasObject.isIrasObject(ref_name)) {
	    coor = IrasObject.getCoor(ref_name);
	} else if (ref_name instanceof MisaoPreliminaryObject) {
	    MisaoPreliminaryObject o = (MisaoPreliminaryObject)ref_name;
	    coor = o.getCoor();
	}
	return new Position(coor.getRA(), coor.getDecl());
    }
}
