/*
 * MisaoPreliminaryObjectName.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.database;

import java.util.*;
import misao.util.*;

public class MisaoPreliminaryObjectName extends VariableStarName {
    private MisaoPreliminaryObject obj;

    public MisaoPreliminaryObjectName ( String name ) {
	String s = name.trim();
	obj = new MisaoPreliminaryObject(s);

	dir = createDir(obj.getCoor());
	file = toFile(s);
    }

    private static String createDir ( Coor coor ) {
	String dir = "misao/";
	dir += Astro.toStringZeroPadding((int)(coor.getRA() / 15.0), 2);
	if (coor.getDecl() < 0.0)
	    dir += "-";
	else
	    dir += "+";
	dir += Astro.toStringZeroPadding((int)(Math.abs((coor.getDecl() + 90.0) - 90) / 10.0) * 10, 2);
	return dir;
    }

    public Vector getAllDirs ( ) {
	Vector list = new Vector();

	AreaManager area_manager = new AreaManager(obj.getCoor(), 100.0 / 3600.0);
	for (int ra = 0 ; ra < 23 ; ra++) {
	    for (int decl = -90 ; decl <= 80 ; decl += 10) {
		Coor start_coor = new Coor(ra * 15, decl);
		Coor end_coor = new Coor((ra + 1) * 15, decl + 10);
		if (area_manager.overlapArea(start_coor, end_coor)) {
		    String s = createDir(new Coor(start_coor.getRA() + 7.5, start_coor.getDecl() + 5.0));
		    list.addElement(s);
		}
	    }
	}

	return list;
    }
}
