/*
 * DifferentialGalleryFrame.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.diff;

import java.awt.*;
import misao.util.*;

public class DifferentialGalleryFrame extends Frame implements Runnable {
    private Thread thread;
    private DifferentialGalleryCanvas canvas;
    private DifferentialPixyOutputData output_data;

    public DifferentialGalleryFrame ( DifferentialPixyOutputData _output_data ) {
	output_data = _output_data;

	init();

	DifferentialCheckImage check_image = new DifferentialCheckImage(output_data);
	Size size = check_image.getGallerySize();
	setSize(size.getWidth() + 10, size.getHeight() + 40 + 25);
    }

    public ImageGray getImage ( ) {
	return canvas.getImage();
    }

    public void init ( ) {
	canvas = new DifferentialGalleryCanvas(output_data);
	setLayout(new FlowLayout());
	add(canvas);
    }

    public void start ( ) {
	thread = new Thread(this);
	thread.start();
    }

    public void stop ( ) {
	if (thread != null) {
	    thread.stop();
	    thread = null;
	}
    }

    public void run ( ) {
	while (true) {
	    try {
		Thread.sleep(100);
	    } catch (InterruptedException e) {
		break;
	    }
	}
    }
}
