/*
 * ReferenceType.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.host;

import java.io.*;

public class ReferenceType {
    public static final ReferenceType REF_P = new ReferenceType('P');
    public static final ReferenceType REF_V = new ReferenceType('V');
    public static final ReferenceType REF_S = new ReferenceType('S');
    public static final ReferenceType REF_E = new ReferenceType('E');
    public static final ReferenceType REF_N = new ReferenceType('N');
    public static final ReferenceType REF_O = new ReferenceType('O');

    private char type;

    private ReferenceType ( ) {
	type = 'O';
    }

    private ReferenceType ( char t ) {
	type = t;
    }

    public static ReferenceType getType ( char c ) {
	switch ( c ) {
	case 'P':  return REF_P;
	case 'V':  return REF_V;
	case 'S':  return REF_S;
	case 'E':  return REF_E;
	case 'N':  return REF_N;
	case 'O':  return REF_O;
	}

	return null;
    }

    public String toString ( ) {
	return "" + type;
    }

    public boolean isMagnitudeObservationTarget ( ) {
	if (type == 'V'  ||  type == 'S'  ||  type == 'E')
	    return true;
	return false;
    }

    public static void printMessage ( PrintStream ps ) {
//	ps.println("P: PIXY data");
	ps.println("V: Variable stars");
	ps.println("S: Suspicious variable stars");
	ps.println("E: Catalog errors");
	ps.println("N: Nebulae or clusters");
	ps.println("O: Other objects");
    }
}
