/*
 * MagnitudeTranslationFormula.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy;

import misao.util.*;

public class MagnitudeTranslationFormula {
    // mag = a + b log(val)
    private double a;
    private double b;

    public MagnitudeTranslationFormula ( double A, double B ) {
	a = A;
	b = B;
    }

    public double calculate ( double val ) {
	return a + b * Math.log(val) / Math.log(Astro.MAG_STEP);
    }

    public double reverseCalculate ( double mag ) {
	return Math.pow(Astro.MAG_STEP, (mag - a) / b);
    }

    public String toString ( ) {
	return "mag = " + b + " log_2.5 ( value ) + " + a;
    }
}
