/*
 * PairType.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy;

import java.awt.Color;

public class PairType {
    public static final PairType PS = new PairType(0);
    public static final PairType RM = new PairType(11);
    public static final PairType RP = new PairType(12);
    public static final PairType NP = new PairType(100);
    public static final PairType ND = new PairType(101);
    public static final PairType NC = new PairType(102);
    public static final PairType NR = new PairType(103);
    public static final PairType NP1 = new PairType(201);
    public static final PairType NP2 = new PairType(202);

    private int type;

    private PairType ( ) {
	type = 0;
    }

    private PairType ( int i ) {
	type = i;
    }

    public boolean isPairStar ( ) {
	return (type == 0);
    }
    public boolean isRemarkableMagnitude ( ) {
	return (type == 11);
    }
    public boolean isRemarkablePosition ( ) {
	return (type == 12);
    }
    public boolean isNonPair ( ) {
	return (type == 100);
    }
    public boolean isNonpairDetected ( ) {
	return (type == 101);
    }
    public boolean isNonpairCatalog ( ) {
	return (type == 102);
    }
    public boolean isNonpairReference ( ) {
	return (type == 103);
    }

    public String getCode ( ) {
	if (isPairStar()) {
	    return "PS";
	} else if (isRemarkableMagnitude()) {
	    return "RM";
	} else if (isRemarkablePosition()) {
	    return "RP";
	} else if (isNonPair()) {
	    return "NP";
	} else if (isNonpairDetected()) {
	    return "ND";
	} else if (isNonpairCatalog()) {
	    return "NC";
	} else if (isNonpairReference()) {
	    return "NR";
	}
	return "";
    }

    public Color getColor ( ) {
	if (isPairStar()) {
	    return Color.green;
	} else if (isRemarkableMagnitude()) {
	    return Color.orange;
	} else if (isRemarkablePosition()) {
	    return Color.blue;
	} else if (isNonPair()) {
	    return Color.red;
	} else if (isNonpairDetected()) {
	    return Color.red;
	} else if (isNonpairCatalog()) {
	    return Color.red;
	} else if (isNonpairReference()) {
	    return Color.magenta;
	}
	return Color.black;
    }
}
