/*
 * RetryManager.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy;

import java.util.*;
import misao.util.*;

public class RetryManager {
    private PixyInputData input_data;
    private Coor default_center_coor;
    private int retry_count;

    public RetryManager ( PixyInputData _input_data ) {
	input_data = _input_data;
	default_center_coor = new Coor(input_data.center_coor);
	retry_count = 0;
    }

    public int getRetryCount ( ) {
	return retry_count;
    }

    public PixyInputData getNextInputData ( ) {
	retry_count++;

	if (retry_count > 8)
	    return null;

	Position pos = new Position(0,0);
	if (retry_count == 1)
	    pos = new Position(-1, 0);
	if (retry_count == 2)
	    pos = new Position( 1, 0);
	if (retry_count == 3)
	    pos = new Position( 0,-1);
	if (retry_count == 4)
	    pos = new Position( 0, 1);
	if (retry_count == 5)
	    pos = new Position(-1,-1);
	if (retry_count == 6)
	    pos = new Position(-1, 1);
	if (retry_count == 7)
	    pos = new Position( 1,-1);
	if (retry_count == 8)
	    pos = new Position( 1, 1);

	pos.rescale(input_data.fov / 3.0);
	input_data.center_coor = new CoorMapping(default_center_coor, pos);
	return input_data;
    }
}
