/*
 * DetectFrame.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy.test;

import java.awt.*;
import misao.util.*;
import misao.pixy.*;

public class DetectFrame extends MainFrame {
    private PixyOutputDataDetect output_data_detect;

    public DetectFrame ( PixyOutputDataDetect data ) throws Exception {
	super();
	view_coor_panel = false;

	output_data_detect = data;

	init();

	setTitle("PIXY system - Control");
	setSize(500, 40 + 25);
	setVisible(true);

	ImageFrame image_frame = new ImageFrame(output_data_detect.image);
	image_frame.show();
	event_manager.add(image_frame);

	MagnitudeTranslationFormula mag_formula = new MagnitudeTranslationFormula(0.0, -1.0);
	output_data_detect.detect_list.translateMagnitude(mag_formula);
	output_data_detect.detect_list.sortMagAscendant();
	double faintest_mag = ((StarData)output_data_detect.detect_list.elementAt(output_data_detect.detect_list.size() * 9 / 10)).getMag();

	ChartFrame detect_frame = new ChartFrame("Detected Stars", output_data_detect.detect_list, output_data_detect.image.getSize(), new MapFunction(), new Position(), faintest_mag);
	detect_frame.show();
	event_manager.add(detect_frame);
    }
}
