/*
 * MatchingFrame.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy.test;

import java.awt.*;
import misao.util.*;
import misao.pixy.*;

public class MatchingFrame extends MainFrame {
    private PixyOutputDataMatching output_data_matching;

    public MatchingFrame ( PixyOutputDataMatching data ) throws Exception {
	super();

	output_data_matching = data;

	init();

	setTitle("PIXY system - Control");
	setSize(700, 80 + 25);
	setVisible(true);

	ImageFrame image_frame = new ImageFrame(output_data_matching.image);
	image_frame.show();
	event_manager.add(image_frame);

	StarData sd;
	int i;

	for (i = 0 ; i < output_data_matching.detect_list.size() ; i++) {
	    sd = (StarData)output_data_matching.detect_list.elementAt(i);
	    sd.setColor(Color.green);

	    StarData sd2 = sd.getFirstAppendix();
	    while (sd2 != null) {
		sd2.setColor(Color.green);
		sd2 = sd.getNextAppendix();
	    }
	}
	for (i = 0 ; i < output_data_matching.check_detect_list.size() ; i++) {
	    sd = (StarData)output_data_matching.check_detect_list.elementAt(i);
	    sd.setColor(Color.blue);

	    StarData sd2 = sd.getFirstAppendix();
	    while (sd2 != null) {
		sd2.setColor(Color.blue);
		sd2 = sd.getNextAppendix();
	    }
	}
	for (i = 0 ; i < output_data_matching.matching_detect_list.size() ; i++) {
	    sd = (StarData)output_data_matching.matching_detect_list.elementAt(i);
	    sd.setColor(Color.red);

	    StarData sd2 = sd.getFirstAppendix();
	    while (sd2 != null) {
		sd2.setColor(Color.red);
		sd2 = sd.getNextAppendix();
	    }
	}

	for (i = 0 ; i < output_data_matching.catalog_list.size() ; i++) {
	    sd = (StarData)output_data_matching.catalog_list.elementAt(i);
	    sd.setColor(Color.green);

	    StarData sd2 = sd.getFirstAppendix();
	    while (sd2 != null) {
		sd2.setColor(Color.green);
		sd2 = sd.getNextAppendix();
	    }
	}
	for (i = 0 ; i < output_data_matching.matching_catalog_list.size() ; i++) {
	    sd = (StarData)output_data_matching.matching_catalog_list.elementAt(i);
	    sd.setColor(Color.red);

	    StarData sd2 = sd.getFirstAppendix();
	    while (sd2 != null) {
		sd2.setColor(Color.red);
		sd2 = sd.getNextAppendix();
	    }
	}

	StarList d_list = new StarList(output_data_matching.detect_list);
	d_list.add(output_data_matching.check_detect_list);
	d_list.add(output_data_matching.matching_detect_list);

	StarList c_list = new StarList(output_data_matching.catalog_list);
	c_list.add(output_data_matching.matching_catalog_list);

	int c_size = output_data_matching.image.getWidth();
	if (c_size < output_data_matching.image.getHeight())
	    c_size = output_data_matching.image.getHeight();
	c_size *= 2;

	MatchingChartFrame detect_frame = new MatchingChartFrame("Detected Stars", d_list, output_data_matching.image.getSize(), new MapFunction(), new Position((double)output_data_matching.image.getWidth() / 2.0, (double)output_data_matching.image.getHeight() / 2.0), output_data_matching.faintest_mag, output_data_matching.tri_graph_detect);
	detect_frame.show();
	event_manager.add(detect_frame);

	MatchingChartFrame catalog_frame = new MatchingChartFrame("Catalog Data", c_list, new Size(c_size, c_size), new MapFunction(), new Position((double)c_size / 2.0, (double)c_size / 2.0), output_data_matching.faintest_mag, output_data_matching.tri_graph_catalog);
	catalog_frame.show();
	event_manager.add(catalog_frame);
    }
}
