/*
 * BeV.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
Code   R.A. (J2000.0) Decl.  Max    Min   Type    Period  Reference           ID               
----------------------------------------------------------------------------------------------------
BeV1   195340.2  +092351    10.5C  11.0C  EA      1.6160  IBVS 4540           GSC1062.33 USNO0975.17237483
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class BeV extends ReferenceCatalog {
    public BeV ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() < 78  ||  ! record.substring(0,3).equals("BeV"))
	    return null;

	String name = record.substring(0,7).trim();
	String dbvs_name = name.toUpperCase();

	CoorMapping coor = new CoorMapping(Coor.createCoor(record.substring(7, 27)));

	String ra = record.substring(7,16).trim();
	String decl = record.substring(17,27).trim();

	String max = record.substring(27,34).trim();
	String min = record.substring(34,41).trim();
	String type = record.substring(42,50).trim();
	String period = record.substring(50,58).trim();
	String reference = record.substring(58,78).trim();
	String id = record.substring(78);

	String s = name + "  R.A.=" + ra.substring(0,2) + "h" + ra.substring(2,4) + "m" + ra.substring(4,6) + "s" + ra.substring(6).trim() + "  Decl.=" + decl.substring(0,3) + "o" + decl.substring(3,5) + "'" + decl.substring(5,7) + "\"" + decl.substring(7).trim() + "  Mag.: " + max + " - " + min;
	if (type.length() > 0)
	    s = s + "  Type: " + type;
	if (period.length() > 0)
	    s = s + "  Period: " + period;
	if (reference.length() > 0)
	    s += "  " + reference;
	if (id.length() > 0)
	    s += "  " + id;

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, s);

	return data;
    }
}
