/*
 * Gcvs.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
ANDR 002401.97 +383439.3 M 5.8 14.9 V 43135 409.33 38 S3,5e-S8,8e(M7e)
ANDS 004243.09 +411605.9 SNI 5.8 <16 V 09775 - - (SNI)
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class Gcvs extends ReferenceCatalog {
    public Gcvs ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	StringTokenizer st = new StringTokenizer(record);
	String dbvs_name = st.nextToken();
	String RA = st.nextToken();
	String Decl = st.nextToken();
	String type = st.nextToken();
	String mag_brightest = st.nextToken();
	String mag_faintest = st.nextToken();
	String mag_code = st.nextToken();
	String epoch = st.nextToken();
	String period = st.nextToken();
	String rising = st.nextToken();
	String spectrum = "-";
	if (st.hasMoreTokens())
	    spectrum = st.nextToken();

	String name = dbvs_name.substring(3) + " " + dbvs_name.substring(0, 3);

	CoorMapping coor = new CoorMapping(Integer.parseInt(RA.substring(0,2)), Integer.parseInt(RA.substring(2,4)), (double)(Float.valueOf(RA.substring(4,9)).floatValue()), (Decl.charAt(0) == '-'), Integer.parseInt(Decl.substring(1,3)), Integer.parseInt(Decl.substring(3,5)), (double)(Float.valueOf(Decl.substring(5,9)).floatValue()));

	record = name + "  R.A.=" + coor.toStringRA() + "  Decl.=" + coor.toStringDecl() + "  ";
	record += mag_brightest + " - " + mag_faintest + " mag";
	if (! mag_code.equals("-"))
	    record += " (" + mag_code + ")";
	if (! type.equals("-"))
	    record += "  type:" + type;
	if (! epoch.equals("-"))
	    record += "  Epoch=" + epoch;
	if (! period.equals("-"))
	    record += "  Period=" + period;
	if (! spectrum.equals("-"))
	    record += "  Sp:" + spectrum;

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
