/*
 * Gcvs4f.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
010001 R    AND*002123+3818.0  +3.17+0.333117.07-23.980000100002M           5.8    14.9     V2443135.                 409.33           38   S3,5E-S8,8E(M7E)
010002 S    AND*003958+4059.7  +3.27+0.329121.17-21.57        BDSN          5.7   (16.      V2409772.       (1885)                          PEC
 *
 */

package misao.ref.catalog;

import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class Gcvs4f extends ReferenceCatalog {
    public Gcvs4f ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() >= 29  &&  record.charAt(16) != ' ') {
	    String name = record.substring(7, 15);
	    String constellation = name.substring(5).trim();
	    String s = name.substring(0, 5).trim();
	    String code = "";
	    for (int i = 0 ; i < s.length() ; i++) {
		if (s.charAt(i) != ' ')
		    code += s.charAt(i);
	    }
	    name = code + " " + constellation;
	    String dbvs_name = constellation.toUpperCase() + code.toUpperCase();

	    CoorMapping coor = new CoorMapping(Integer.parseInt(record.substring(16,18).trim()), Integer.parseInt(record.substring(18,20).trim()), (record.charAt(20) == ' ' ? 0.0 : (double)(Float.valueOf(record.substring(20,22).trim()).floatValue())), (record.charAt(22) == '-'), Integer.parseInt(record.substring(23,25).trim()), Integer.parseInt(record.substring(25,27).trim()), (record.charAt(28) == ' ' ? 0.0 : (double)(Float.valueOf(record.substring(28,29).trim()).floatValue())) / 10.0 * 60.0);
	    coor.precession(new JulianDay(Astro.BESSELL_1950), new JulianDay(Astro.JULIUS_2000));

	    record += "                    ";
	    s = name + "  R.A.=" + coor.toStringRA() + "  Decl.=" + coor.toStringDecl() + "  ";
	    if (record.length() >= 82) {
		s += record.substring(73, 82).trim();
		if (record.length() >= 92)
		    s += " - " + record.substring(82, 92).trim();
		s += " mag";
		if (record.length() >= 93)
		    s += " (" + record.charAt(92) + ")  ";
	    }
	    if (record.length() >= 73) {
		s += "type:" + record.substring(64, 73).trim() + "  ";
	    }
	    if (record.length() >= 107  &&  record.substring(93, 107).trim().length() > 0) {
		s += "Epoch=" + record.substring(93, 107).trim();
		if (record.length() >= 108  &&  record.charAt(107) != ' ')
		    s += record.charAt(107);
		s += "  ";
	    }
	    if (record.length() >= 132  &&  record.substring(116, 132).trim().length() > 0) {
		s += "Period=";
		if (record.charAt(115) != ' ')
		    s += record.charAt(115);
		s += record.substring(116, 132).trim();
		if (record.length() >= 134)
		    s += record.substring(132, 134).trim();
		s += "  ";
	    }
	    if (record.length() >= 114  &&  record.substring(108, 114).trim().length() > 0) {
		s += "Nova in " + record.substring(108, 114).trim();
		if (record.length() >= 115  &&  record.charAt(114) != ' ')
		    s += record.charAt(114);
		s += "  ";
	    }

	    ReferenceData data = new ReferenceData(name, dbvs_name, coor, s);

	    return data;
	}

	return null;
    }
}
