/*
 * MisF.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
MisF -- Faint cometary objects discovered by the MISAO Project.

ID        R.A.      Decl.     Mag
------------------------------------
MisF00001 065826.60 +410846.3 17
 *
 */

package misao.ref.catalog;

import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class MisF extends ReferenceCatalog {
    public MisF ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() < 29)
	    return null;
	if (record.substring(0, 8).equals("MisF -- "))
	    return null;

	if (! record.substring(0, 4).equals("MisF"))
	    return null;

	String name = record.substring(0, 9);
	String dbvs_name = name.toUpperCase();

	CoorMapping coor = new CoorMapping(Coor.createCoor(record.substring(10,29)));

	String record0 = name + "  R.A.=" + coor.toStringRA() + "  Decl.=" + coor.toStringDecl();
	if (record.length() > 30)
	    record0 = record0 + "  " + record.substring(30) + " mag";

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record0);

	return data;
    }
}
