/*
 * OgleLt.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
Variable 
Star     Field     RA_2000      DEC_2000      I     (V-I)  Remarks
OGLE-LT- 

V001     MM1B    18:06:51.92  -26:53:45.5   14.241  2.204    lt 
V006     BW9     18:00:33.47  -29:44:52.6   14.649  4.686  Mira,lh 
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class OgleLt extends ReferenceCatalog {
    public OgleLt ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() < 4)
	    return null;

	if (! (record.charAt(0) == 'V'  &&  
	    '0' <= record.charAt(1)  &&  record.charAt(1) <= '9'  &&
	    '0' <= record.charAt(2)  &&  record.charAt(2) <= '9'  &&
	    '0' <= record.charAt(3)  &&  record.charAt(2) <= '3'))
	    return null;

	StringTokenizer st = new StringTokenizer(record, " ");
	String name = "OGLE-LT-" + st.nextToken();
	String dbvs_name = name;
	String field = st.nextToken();
	String ra = st.nextToken();
	String decl = st.nextToken();
	String Imag = st.nextToken();
	String VImag = st.nextToken();
	String remarks = st.nextToken();

	CoorMapping coor = new CoorMapping(Integer.parseInt(ra.substring(0,2)), Integer.parseInt(ra.substring(3,5)), (double)Float.valueOf(ra.substring(6,11)).floatValue(), (decl.charAt(0) == '-'), Integer.parseInt(decl.substring(1,3)), Integer.parseInt(decl.substring(4,6)), (double)Float.valueOf(decl.substring(7,11)).floatValue());

	record = name + "  " + ra + "  " + decl + "  I:" + Imag + " mag";
	if (! VImag.equals("---"))
	    record += "  V-I:" + VImag + " mag";
	record += "  Field:" + field + "  " + remarks;

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
