/*
 * Stm.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
-----------------------------------------------------
 No.     R.A.   Decl.    Mag       Obs.DATA
-----------------------------------------------------
0001    120.08 510111.2  9.6
0055  11140.70 333105.2  6.1 199807192550 <98 Stm
 *
 */

package misao.ref.catalog;

import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class Stm extends ReferenceCatalog {
    public Stm ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	String name = record.substring(0,4);
	if (name.equals("----")  ||  name.equals(" No."))
	    return null;

	name = "STM" + name.trim();
	String dbvs_name = name.toUpperCase();

	String ra_decl = record.substring(5, 23).replace(' ', '0');

	boolean south_flag = false;
	if (ra_decl.indexOf('-') >= 0) {
	    ra_decl = ra_decl.replace('-', '0');
	    south_flag = true;
	}

	CoorMapping coor = new CoorMapping(Integer.parseInt(ra_decl.substring(0,2)), Integer.parseInt(ra_decl.substring(2,4)), (double)Float.valueOf(ra_decl.substring(4, 9)).floatValue(), south_flag, Integer.parseInt(ra_decl.substring(10,12)), Integer.parseInt(ra_decl.substring(12,14)), (double)Float.valueOf(ra_decl.substring(14,18)).floatValue());

	record = name + "  R.A.=" + coor.toStringRA() + "  Decl.=" + coor.toStringDecl() + "  " + record.substring(24, 28).trim() + " mag";

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
