/*
 * CdromListUSNOA10.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.io.*;
import java.util.Vector;

public class CdromListUSNOA10 extends CdromListUSNO {
    private static final int USNOA10_cat_N = 24;
    private static final int USNOA10_file[] = {
	   0,   75,  450,  375, 1500, 1650,  300, 1425,
	1725,  525, 1275,  225,  675,  150,  600, 1575,
	 750,  975,  900, 1050, 1125, 1200,  825, 1350
    };
    private static final int USNOA10_disk[] = {
	 1,  1,  1,  2,  2,  2,  3,  3,
	 3,  4,  4,  5,  5,  6,  6,  6,
	 7,  7,  8,  8,  9,  9, 10, 10
    };

    public CdromListUSNOA10 ( ) {
	super();

	mode = USNO_V;
    }

    protected int getNumberOfFiles ( ) {
	return USNOA10_cat_N;
    }

    protected int getFileNumber ( int i ) {
	return USNOA10_file[i];
    }

    protected int getDiskNumber ( int i ) {
	return USNOA10_disk[i];
    }

    protected String getVersion ( ) {
	return "A1.0";
    }
}
