/*
 * CdromListUSNOA20.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.io.*;
import java.util.Vector;

public class CdromListUSNOA20 extends CdromListUSNO {
    private static final int USNOA20_cat_N = 24;
    private static final int USNOA20_file[] = {
	   0,   75,  600,  525, 1500, 1725,  450, 1575, 
	1650,  375, 1425,  300,  675, 1350,  225,  750, 
	 975, 1050,  150,  900,  825, 1200, 1125, 1275
    };
    private static final int USNOA20_disk[] = {
	 1,  1,  1,  2,  2,  2,  3,  3, 
	 3,  4,  4,  5,  6,  6,  7,  7, 
	 8,  8,  9,  9, 10, 10, 11, 11
    };

    public CdromListUSNOA20 ( ) {
	super();

	mode = USNO_V;
    }

    protected int getNumberOfFiles ( ) {
	return USNOA20_cat_N;
    }

    protected int getFileNumber ( int i ) {
	return USNOA20_file[i];
    }

    protected int getDiskNumber ( int i ) {
	return USNOA20_disk[i];
    }

    protected String getVersion ( ) {
	return "A2.0";
    }
}
