/*
 * CgiListGSC.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

public class CgiListGSC extends CgiList {
    protected static final String urlCGI = "http://www-gsss.stsci.edu/htbin/gsc12_request.com";

    public void load ( Coor center_coor, double fov, double mag ) throws Exception {
	setUnit(fov);

	String mag_str = "";
	if (mag > 30.0)
	    mag_str = "30.0";
	else if (-0.1 <= mag  &&  mag <= 0.1)
	    mag_str = "0.0";
	else {
	    mag_str = "" + mag;
	    if (mag_str.length() > 6)
		mag_str = mag_str.substring(0,6);
	}

	String arg = "RAH=" + center_coor.getRA_h() + "&RAM=" + center_coor.getRA_m() + "&RAS=" + center_coor.getRA_s() + "&DSN=" + (center_coor.getDecl() < 0.0 ? "-" : "%2B") + "&DD=" + center_coor.getAbsDecl_d() + "&DM=" + center_coor.getAbsDecl_m() + "&DS=" + center_coor.getAbsDecl_s() + "&EQ=J2000&SIZE=" + (int)(fov * 60.0) + "&FORMAT=Plain+Text";

	try {
	    openConnectionPost(urlCGI, arg);
	} catch ( Exception e ) {
	    throw e;
	}

	String record = null;
	double m;

	try {
	    record = readLine();
	} catch ( Exception e ) {
	    throw e;
	}

	while (record != null) {
	    if (record.length() == 89) {
		if ((record.charAt(17) == ' '  ||  ('0' <= record.charAt(17)  &&  record.charAt(17) <= '9'))  &&
		    '0' <= record.charAt(18)  &&  record.charAt(18) <= '9'  &&
		    record.charAt(19) == ' '  &&
		    (record.charAt(20) == ' '  ||  ('0' <= record.charAt(20)  &&  record.charAt(20) <= '9'))  &&
		    '0' <= record.charAt(21)  &&  record.charAt(21) <= '9'  &&
		    record.charAt(22) == ' '  &&
		    (record.charAt(23) == ' '  ||  ('0' <= record.charAt(23)  &&  record.charAt(23) <= '9'))  &&
		    '0' <= record.charAt(24)  &&  record.charAt(24) <= '9'  &&
		    (record.charAt(17) == ' '  ||  record.charAt(25) == '.')  &&
		    (record.charAt(26) == ' '  ||  ('0' <= record.charAt(26)  &&  record.charAt(26) <= '9'))  &&
		    (record.charAt(27) == ' '  ||  ('0' <= record.charAt(27)  &&  record.charAt(27) <= '9'))  &&
		    record.charAt(28) == ' '  &&
		    (record.charAt(29) == '+'  ||  record.charAt(29) == '-')  &&
		    (record.charAt(30) == ' '  ||  ('0' <= record.charAt(30)  &&  record.charAt(30) <= '9'))  &&
		    '0' <= record.charAt(31)  &&  record.charAt(31) <= '9'  &&
		    record.charAt(32) == ' '  &&
		    (record.charAt(33) == ' '  ||  ('0' <= record.charAt(33)  &&  record.charAt(33) <= '9'))  &&
		    '0' <= record.charAt(34)  &&  record.charAt(34) <= '9'  &&
		    record.charAt(35) == ' '  &&
		    (record.charAt(36) == ' '  ||  ('0' <= record.charAt(36)  &&  record.charAt(36) <= '9'))  &&
		    '0' <= record.charAt(37)  &&  record.charAt(37) <= '9'  &&
		    (record.charAt(17) == ' '  ||  record.charAt(38) == '.')  &&
		    (record.charAt(39) == ' '  ||  ('0' <= record.charAt(39)  &&  record.charAt(39) <= '9'))  &&
		    record.charAt(40) == ' '  &&
		    (record.charAt(41) == ' '  ||  ('0' <= record.charAt(41)  &&  record.charAt(41) <= '9'))  &&
		    '0' <= record.charAt(42)  &&  record.charAt(42) <= '9'  &&
		    record.charAt(43) == '.'  &&
		    '0' <= record.charAt(44)  &&  record.charAt(44) <= '9'  &&
		    record.charAt(45) == ' '  &&
		    (record.charAt(46) == ' '  ||  record.charAt(46) == '-'  ||  ('0' <= record.charAt(46)  &&  record.charAt(46) <= '9'))  &&
		    (record.charAt(47) == ' '  ||  record.charAt(47) == '-'  ||  ('0' <= record.charAt(47)  &&  record.charAt(47) <= '9'))  &&
		    '0' <= record.charAt(48)  &&  record.charAt(48) <= '9'  &&
		    record.charAt(49) == '.'  &&
		    '0' <= record.charAt(50)  &&  record.charAt(50) <= '9'  &&
		    '0' <= record.charAt(51)  &&  record.charAt(51) <= '9'  &&
		    record.charAt(52) == ' '  &&
		    '0' <= record.charAt(53)  &&  record.charAt(53) <= '9'  &&
		    record.charAt(54) == '.'  &&
		    '0' <= record.charAt(55)  &&  record.charAt(55) <= '9'  &&
		    '0' <= record.charAt(56)  &&  record.charAt(56) <= '9'  &&
		    (record.charAt(72) == 'F'  ||  record.charAt(72) == 'T')  &&
		    (record.charAt(73) == 'F'  ||  record.charAt(73) == 'T')  &&
		    (record.charAt(74) == 'F'  ||  record.charAt(74) == 'T')  &&
		    (record.charAt(75) == 'F'  ||  record.charAt(75) == 'T')  &&
		    (record.charAt(76) == 'F'  ||  record.charAt(76) == 'T')  &&
		    (record.charAt(77) == 'F'  ||  record.charAt(77) == 'T')  &&
		    (record.charAt(78) == 'F'  ||  record.charAt(78) == 'T')  &&
		    (record.charAt(79) == 'F'  ||  record.charAt(79) == 'T')) {

		    // R.A. and Decl.
		    CoorMapping coor = new CoorMapping(Integer.parseInt(record.substring(17,19).trim()), Integer.parseInt(record.substring(20,22).trim()), (double)(Float.valueOf(record.substring(23,28).trim()).floatValue()), (record.charAt(29) == '-'), Integer.parseInt(record.substring(30,32).trim()), Integer.parseInt(record.substring(33,35).trim()), (double)(Float.valueOf(record.substring(36,40).trim()).floatValue()));

		    m = ((double)(Float.valueOf(record.substring(47,52).trim()).floatValue()));

		    if (m <= mag) {
			String id = record.substring(4,8) + "." + record.substring(12,16);
			id = "GSC" + id.replace(' ', '0');

			if (isModeSimple()) {
			    record = id + "  " + record.substring(17,28) + "  " + record.substring(29,40) + "  " + record.substring(47,52);
			} else if (isModeDetail()) {
			    record = id + "  R.A.=" + record.substring(17,28) + "  Decl.=" + record.substring(29,40) + " (+/-" + record.substring(41,45).trim() + "\")  Mag=" + record.substring(47,52) + " (+/-" + record.substring(53,57) + ")  band=" + record.substring(58,60).trim() + "  class=" + record.substring(61,63) + "  plate=" + record.substring(64,68) + "  n=" + record.substring(70,71) + "  IIPDGBFN=" + record.substring(72,80) + "  Epoch=" + record.substring(81,89);
			} else {
			    record = null;
			    id = null;
			}

			addStar(center_coor, coor, m, id, record);
		    }
		}
	    }

	    try {
		record = readLine();
	    } catch ( Exception e ) {
		throw e;
	    }
	}
	close();
    }
}
