/*
 * CgiListTycho.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

public class CgiListTycho extends CgiList {
    protected static final String urlCGI = "http://133.9.68.42/seiichi/tycho/tybv.cgi";

    public void load ( Coor center_coor, double fov, double mag ) throws Exception {
	setUnit(fov);

	String arg = "RA=" + String.valueOf(center_coor.getRA()) + "&Decl=" + String.valueOf(center_coor.getDecl()) + "&range=" + String.valueOf(fov) + "&mag=" + String.valueOf(mag);

	try {
	    openConnectionPost(urlCGI, arg);
	} catch ( Exception e ) {
	    throw e;
	}

	String record = null;
	double m;

	try {
	    record = readLine();
	} catch ( Exception e ) {
	    throw e;
	}

	while (record != null) {
	    try {
		// R.A. and Decl.
		CoorMapping coor = new CoorMapping(Integer.parseInt(record.substring(0,2)), Integer.parseInt(record.substring(2,4)), (double)(Float.valueOf(record.substring(4,9)).floatValue()), (record.charAt(10) == '-'), Integer.parseInt(record.substring(11,13)), Integer.parseInt(record.substring(13,15)), (double)(Float.valueOf(record.substring(15,19)).floatValue()));

		m = (double)Integer.parseInt(record.substring(20,24).trim()) * 0.01;

		if (m <= mag) {
		    if (isModeSimple()) {
			record = record.substring(0,2) + "h" + record.substring(2, 4) + "m" + record.substring(4,6) + "s" + record.substring(6,9) + "  " + record.substring(10,13) + "o" + record.substring(13,15) + "'" + record.substring(15,17) + "\"" + record.substring(17,19) + "  " + record.substring(20,22) + "." + record.substring(22,25);
		    } else if (isModeDetail()) {
			String bv = "";
			if (record.charAt(25) == '-')
			    bv = "-";
			if (record.charAt(26) == ' ')
			    bv = "0";
			else if (record.charAt(26) == '-')
			    bv = "-0";
			else
			    bv = bv + record.substring(26,27);
			bv = bv + ".";
			if (record.charAt(27) == ' ')
			    bv = bv + "0";
			else if (record.charAt(27) == '-')
			    bv = "-0.0";
			else
			    bv = bv + record.substring(27,28);
			bv = bv + record.substring(28,29);

			record = "R.A.=" + record.substring(0,2) + "h" + record.substring(2, 4) + "m" + record.substring(4,6) + "s" + record.substring(6,9) + "  Decl.=" + record.substring(10,13) + "o" + record.substring(13,15) + "'" + record.substring(15,17) + "\"" + record.substring(17,19) + "  Johnson V mag=" + record.substring(20,22) + "." + record.substring(22,25) + "  B-V=" + bv;
		    } else {
			record = null;
		    }

		    addStar(center_coor, coor, m, null, record);
		}
	    } catch (StringIndexOutOfBoundsException e) {
		System.err.print("StringIndexOutOfBoundsException: " + record);
	    } catch (NumberFormatException e) {
		System.err.print("NumberFormatException: " + record);
	    }

	    try {
		record = readLine();
	    } catch ( Exception e ) {
		throw e;
	    }
	}
	close();
    }
}
