/*
 * CgiListYcbs.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

public class CgiListYcbs extends CgiList {
    protected static final String urlCGI = "http://133.9.68.42/seiichi/ybs3/ybs3.cgi";

    public void load ( Coor center_coor, double fov, double mag ) throws Exception {
	setUnit(fov);

	String arg = "RA=" + String.valueOf(center_coor.getRA()) + "&Decl=" + String.valueOf(center_coor.getDecl()) + "&range=" + String.valueOf(fov) + "&mag=" + String.valueOf(mag);

	try {
	    openConnectionPost(urlCGI, arg);
	} catch ( Exception e ) {
	    throw e;
	}

	String record = null;
	double m;

	try {
	    record = readLine();
	} catch ( Exception e ) {
	    throw e;
	}

	while (record != null) {
	    try {
		// R.A. and Decl.
		CoorMapping coor = new CoorMapping(Integer.parseInt(record.substring(88,90).trim()), Integer.parseInt(record.substring(90,92).trim()), (double)Integer.parseInt(record.substring(92,94).trim()), (record.charAt(99) == '-'), Integer.parseInt(record.substring(100,102).trim()), Integer.parseInt(record.substring(102,104).trim()), 0.0);

		m = (double)Integer.parseInt(record.substring(108,111).trim()) * 0.01;
		if (record.charAt(107) == '-')
		    m = - m;

		if (m <= mag) {
		    String id = record.substring(0,4).trim();
		    if (isModeNull()) {
			id = null;
			record = null;
		    } else {
			record = "ID=" + id + "  R.A.=" + record.substring(88,90) + "h" + record.substring(90,92) + "m" + record.substring(92,94) + "s" + "  Decl.=" + record.substring(99,102) + "o" + record.substring(102,104) + "'";

			record += "  mag=" + record.substring(107,108);
			if (record.charAt(108) == ' ')
			    record += "0";
			else
			    record += record.substring(108,109);
			record += "." + record.substring(109,111);

			String magsrc = record.substring(111,113).trim();
			if (magsrc.length() > 0)
			    magsrc = "(" + magsrc + ")";
			record += magsrc;

			record += "  B-V=" + record.substring(113,114);
			if (record.charAt(114) == ' ')
			    record += "0";
			else
			    record += record.substring(114,115);
			record += "." + record.substring(115,117);

			record += "  spectrum=";
			for (int j = 117 ; j < 139 ; j++) {
			    if (record.charAt(j) != ' ')
				record += record.substring(j,j+1);
			}
		    }

		    addStar(center_coor, coor, m, id, record);
		}
	    } catch (StringIndexOutOfBoundsException e) {
		System.err.print("StringIndexOutOfBoundsException: " + record);
	    } catch (NumberFormatException e) {
		System.err.print("NumberFormatException: " + record);
	    }

	    try {
		record = readLine();
	    } catch ( Exception e ) {
		throw e;
	    }
	}
	close();
    }
}
