/*
 * ImageCanvas.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.awt.*;

public class ImageCanvas extends Canvas {
    Image image;
    Size size;
    Point mark_pt;
    Color mark_color;

    public ImageCanvas ( Size s ) {
	this (null, s);
    }

    public ImageCanvas ( Image i, Size s ) {
	image = i;
	size = s;
	mark_pt = new Point(-1, -1);
	mark_color = Color.magenta;
	resize(size.getWidth(), size.getHeight());
    }

    public void setImage ( Image i ) {
	image = i;
    }

    public void setMark ( Point pt ) {
	mark_pt = pt;
    }

    public void setMarkColor( Color c ) {
	mark_color = c;
    }

    public void paint ( Graphics g ) {
	update(g);
    }

    public void update ( Graphics g ) {
	if (image != null)
	    g.drawImage(image, 0, 0, this);

	if (0 <= mark_pt.x  &&  mark_pt.x < size.getWidth()  &&  0 <= mark_pt.y  &&  mark_pt.y < size.getHeight()) {
	    g.setColor(mark_color);
	    g.drawOval(mark_pt.x - 6, mark_pt.y - 6, 12, 12);
	    g.drawOval(mark_pt.x - 7, mark_pt.y - 7, 14, 14);
	    g.drawOval(mark_pt.x - 8, mark_pt.y - 8, 16, 16);
	}
    }
}
