/*
 * MovingAverage.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

public class MovingAverage {
    private double[] data;
    private int count;
    private int ptr;

    public MovingAverage ( int size ) {
	data = new double[size];
	count = 0;
	ptr = 0;
    }

    public void add ( double f ) {
	data[ptr++] = f;
	if (ptr >= data.length)
	    ptr = 0;
	count++;
	if (count > data.length)
	    count = data.length;
    }

    public int getCount ( ) {
	return count;
    }

    public double getAverage ( ) {
	if (count == 0)
	    return 0.0;

	double f = 0.0;
	for (int i = 0 ; i < count ; i++)
	    f += data[i];
	return f / (double)count;
    }
}
