/*
 * Parameter.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.io.*;

public class Parameter implements Printable {
    private static String delimiter = "=";

    private String key;
    private String value;

    private Parameter ( ) {
	key = "";
	value = "";
    }

    public Parameter ( String s ) {
	this();

	int p = s.indexOf(delimiter);
	if (p < 0)
	    key = s;
	else {
	    key = s.substring(0, p);
	    if (p+1 < s.length())
	    value = s.substring(p+1);
	}
    }

    public Parameter ( String _key, String _value ) {
	key = _key;
	value = _value;
    }

    public Parameter ( String _key, boolean _value ) {
	key = _key;
	value = (_value ? "y" : "n");
    }

    public String getKey ( ) {
	return key;
    }

    public String getValue ( ) {
	return value;
    }

    public String toString ( ) {
	return key + delimiter + value;
    }

    public void print ( PrintStream ps ) {
	ps.println(toString());
    }
}
