/*
 * PositionList.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.lang.Math;
import java.util.Vector;

public class PositionList {
    private Vector list;

    public PositionList () {
	list = new Vector();
    }

    public int size ( ) {
	return list.size();
    }

    public void addElement ( Position p ) {
	list.addElement(p);
    }

    public Graph createMinimumGlobalTree ( ) {
	Graph tree = new Graph(size());

	double[][] distance = new double[size()][size()];
	for (int i = 0 ; i < size() ; i++) {
	    for (int j = i + 1 ; j < size() ; j++) {
		Position p1 = (Position)list.elementAt(i);
		Position p2 = (Position)list.elementAt(j);
		distance[i][j] = Math.sqrt((p1.getX() - p2.getX()) * (p1.getX() - p2.getX()) + (p1.getY() - p2.getY()) * (p1.getY() - p2.getY()));
	    }
	}
	for (int i = 0 ; i < size() ; i++) {
	    distance[i][i] = -1.0;
	}

	for (int k = 0 ; k < size() - 1 ; k++) {
	    double min = -1.0;
	    int min_i = -1;
	    int min_j = -1;
	    for (int i = 0 ; i < size() ; i++) {
		for (int j = i + 1 ; j < size() ; j++) {
		    if (distance[i][j] > 0.0  &&  (distance[i][j] < min  ||  min < 0.0)) {
			min = distance[i][j];
			min_i = i;
			min_j = j;
		    }
		}
	    }

	    tree.connect(min_i, min_j);

	    int[] reachable_list = tree.getIndexListReachable(min_i);
	    for (int i = 0 ; i < reachable_list.length ; i++) {
		for (int j = 0 ; j < reachable_list.length ; j++) {
		    distance[reachable_list[i]][reachable_list[j]] = -1.0;
		    distance[reachable_list[j]][reachable_list[i]] = -1.0;
		}
	    }
	}

	return tree;
    }
}
